package
{
	/**
	 * ...
	 * @author Elliot Hatch
	 */
	import adobe.utils.CustomActions;
	import mx.core.FlexSprite;
	import org.flixel.*;
	import org.flixel.plugin.photonstorm.FlxPowerTools;
	
	public class PlayState extends FlxState
	{
		private var gameMode:int = 0;
		//game modes
		private var MODE_COIN:int = 0;
		private var MODE_TURN:int = 1;
		private var MODE_RECIEVE:int = 2;
		
		private var dispenserOffsetX:Number = 100;
		private var cameraPan02Y:Number = 200;
		
		private var cameraPan01Timer:FlxTimer;
		private var cameraPan01:Boolean = false;
		private var cameraPan02Timer:FlxTimer;
		private var cameraPan02:Boolean = false;
		private var cameraPan02Primed:Boolean = false;
		
		private var mallBackgroundSprite:FlxSprite;
		
		private var cursor:FlxSprite;
		private var openHandCollider:FlxSprite;
		
		private var handSprite:FlxSprite;
		private var handCoinSprite:FlxSprite;
		private var handTurnSprite:FlxSprite;
		private var armSprite:FlxSprite;
		private var handRecievingSprite:FlxSprite;
		private var cursorDotSprite:FlxSprite;
		
		private var gravity:Number = 600;
		
		private var coin:FlxSprite;
		private var coinFeed:FlxSprite;
		private var coinCover:FlxSprite;
		
		private var coinIsHeld:Boolean = false;
		private var handleIsHeld:Boolean = false;
		
		private var dispenserCollider:FlxSprite;
		private var dispenserHandle:FlxSprite;
		private var dispenserSprite:FlxSprite;
		private var flapSprite:FlxSprite;
		private var lastMouseXY:FlxPoint;
		
		private var totalTheta:Number = 0;
		private var goalTheta:Number = 360;
		private var snapbackThetaMax:Number = 45;
		private var snapbackThetaMin:Number = 0;
		private var currentSnap:Number = 0;
		private var snapAmount:Number = 10;
		
		private var cursorTrail:FlxEmitter;
		
		[Embed(source = "../images/vending machine barex2.png")] private var dispenserImage:Class;
		[Embed(source = "../images/Handlex2.png")] private var handleImage:Class; //194x50
		[Embed(source = "../images/flapx2.png")] private var flapImage:Class;
		[Embed(source = "../images/flapUnderSidex2.png")] private var flapUnderImage:Class;
		[Embed(source = "../images/Quarterx2.png")] private var coinImage:Class;
		[Embed(source = "../images/MouseDot.png")] private var cursorDotImage:Class;
		[Embed(source = "../images/CoinCover.png")] private var coinCoverImage:Class;
		[Embed(source = "../images/hand.png")] private var handImage:Class;
		[Embed(source = "../images/handQuarter.png")] private var handCoinImage:Class;
		[Embed(source = "../images/HandOnHandle.png")] private var handOnHandleImage:Class;
		[Embed(source = "../images/arm.png")] private var armImage:Class;
		
		[Embed(source = "../images/MallBackground.png")] private var mallBackgroundImage:Class;
		
		[Embed(source = "../sounds/MallSounds.mp3")] private var mallBgSounds:Class;
		
		
		override public function create():void
		{
			super.create();
			FlxG.bgColor = 0xffffffff;
			
			coin = new FlxSprite(70, 70);
			coin.loadGraphic(coinImage);
			//coin.makeGraphic(40, 40, 0xffaaaaaa);
			
			coinFeed = new FlxSprite(FlxG.width / 2 - 48 / 2 + dispenserOffsetX, 120);
			coinFeed.makeGraphic(48, 48, 0xdddddddd);
			
			coinCover = new FlxSprite(FlxG.width / 2 - 178 / 2 + dispenserOffsetX, 136);
			coinCover.loadGraphic(coinCoverImage);//178x59
			
			mallBackgroundSprite = new FlxSprite(0, 0);
			mallBackgroundSprite.loadGraphic(mallBackgroundImage);
			mallBackgroundSprite.origin.x = 0;
			mallBackgroundSprite.origin.y = 0;
			mallBackgroundSprite.scale.x = 1.5;
			mallBackgroundSprite.scale.y = 1.5;
			
			//coinInsertedSprite = new FlxSprite(FlxG.width / 2 - 38 / 2, 140)
			
			dispenserCollider = new FlxSprite(FlxG.width/2 - 194/2 + dispenserOffsetX, 480/2 - 194/2);
			dispenserCollider.makeGraphic(194, 194, 0xffeeffee);
			
			dispenserHandle = new FlxSprite(FlxG.width/2 - 194/2 + dispenserOffsetX, 480/2 - 50/2);
			//dispenserHandle.makeGraphic(100, 30, 0xff333333);
			dispenserHandle.loadGraphic(handleImage); //194x50
			
			dispenserSprite = new FlxSprite(FlxG.width / 2 - 568 / 2 - 5 + dispenserOffsetX, 60);
			dispenserSprite.loadGraphic(dispenserImage); //568x1076
			dispenserSprite.offset.y = 1076 - 480;
			
			flapSprite = new FlxSprite(FlxG.width / 2 - 124 / 2 + 4 + dispenserOffsetX, 480 - 100);
			flapSprite.loadGraphic(flapImage); //124x124
			
			handSprite = new FlxSprite(0, 0);
			handSprite.loadGraphic(handImage); //200x526
			handSprite.offset.x = 80;
			handSprite.offset.y = 120;
			//handSprite.makeGraphic(10, 10, 0xff000000);
			handCoinSprite = new FlxSprite(0, 0);
			handCoinSprite.loadGraphic(handCoinImage); //183x438
			handCoinSprite.offset.x = 30;
			handCoinSprite.offset.y = 90;
			//handCoinSprite.makeGraphic(10, 10, 0xffffaaaa);
			handCoinSprite.visible = false;
			handTurnSprite = new FlxSprite(dispenserHandle.x + dispenserHandle.width / 2 - 200 / 2 + 3,
											dispenserHandle.y + dispenserHandle.height / 2 - 144 / 2 + 13);
			handTurnSprite.loadGraphic(handOnHandleImage); //201x144
			handTurnSprite.origin.x = dispenserHandle.width / 2;
			handTurnSprite.origin.y = 60;
			
			//handTurnSprite.origin.y = dispenserHandle.height / 2 + 13;
			//handTurnSprite.makeGraphic(10, 10, 0xffaaaaff);
			//handTurnSprite.loadGraphic(handCoinImage);
			handTurnSprite.visible = false;
			
			armSprite = new FlxSprite(dispenserHandle.x + dispenserHandle.width / 2, dispenserHandle.y + dispenserHandle.height / 2);
			armSprite.loadGraphic(armImage);
			armSprite.visible = false;
			
			handRecievingSprite = new FlxSprite(0, 0);
			handRecievingSprite.makeGraphic(30, 30, 0xffffffaa);
			handRecievingSprite.visible = false;
			
			openHandCollider = new FlxSprite(0, 0);
			openHandCollider.makeGraphic(160, 200, 0xff000000);
			openHandCollider.alpha = 0.5
			
			cursorDotSprite = new FlxSprite(0, 0);
			cursorDotSprite.loadGraphic(cursorDotImage);
			cursorDotSprite.alpha = 0.1;
			cursorDotSprite.visible = false;
						
			cursorTrail = new FlxEmitter(0, 0, 8);
			cursorTrail.setXSpeed(0, 0);
			cursorTrail.setYSpeed(0, 0);
			cursorTrail.setRotation(0, 0);
			
			for (var i:int = 0; i < cursorTrail.maxSize; i++)
			{
				var cursorTrailParticle:CursorTrailParticle = new CursorTrailParticle(0.2, 0.1);
				cursorTrailParticle.loadGraphic(cursorDotImage);
				cursorTrail.add(cursorTrailParticle);
				cursorTrailParticle.kill();
			}
						
			cursor = handSprite;
			
			cameraPan01Timer = new FlxTimer();
			cameraPan02Timer = new FlxTimer();
			
			add(mallBackgroundSprite);
			
			add(dispenserSprite);
			add(flapSprite);
			//add(coinFeed);
			//add(dispenserCollider);
			add(coin);
			add(coinCover);
			add(dispenserHandle);
			
			add(handSprite);
			add(handCoinSprite);
			//add(armSprite);
			add(handTurnSprite);
			add(armSprite);
			add(handRecievingSprite);
			add(cursorTrail);
			add(cursorDotSprite);
			//add(openHandCollider);
			FlxG.playMusic(mallBgSounds, 0.5);
		}
		
		override public function update():void
		{
			cursor.x = FlxG.mouse.x;
			cursor.y = FlxG.mouse.y;
			openHandCollider.x = FlxG.mouse.x - openHandCollider.width / 2;
			openHandCollider.y = FlxG.mouse.y - openHandCollider.height / 2;
					
			if (cursorDotSprite.visible)
			{
				cursorTrail.x = cursor.x + cursor.width / 2;
				cursorTrail.y = cursor.y + cursor.height / 2;
				cursorTrail.emitParticle();
				
			}
			
			
			switch (gameMode)
			{
				case MODE_COIN: 
				{
					updateModeCoin();
					break;
				}
				case MODE_TURN: 
				{
					updateModeTurn();
					break;
				}
				
				case MODE_RECIEVE:
				{
					updateModeRecieve();
					break;
				}
			}

			updateDispenserTurn();			
			super.update();
			
			updateCinematics();
			lastMouseXY = FlxG.mouse.getWorldPosition();
		}
		
		private function updateCinematics():void
		{
			if (cameraPan01)
			{
				FlxG.camera.x = -dispenserOffsetX * (-0.5 * Math.cos(Math.PI * cameraPan01Timer.progress) + 0.5);
				if (cameraPan01Timer.finished)
				{
					cameraPan01 = false;
					FlxG.camera.x = -dispenserOffsetX;
				}
			}
			if (cameraPan02)
			{
				cameraPan02Primed = false;
				FlxG.camera.y = -cameraPan02Y * (-0.5 * Math.cos(Math.PI * cameraPan02Timer.progress) + 0.5);
				if (cameraPan02Timer.finished)
				{
					
					cameraPan02 = false;
					FlxG.camera.y = -cameraPan02Y;
				}
			}
		}
		
		private function updateModeCoin():void
		{
			if (FlxG.mouse.justPressed() && coin.overlaps(openHandCollider))
					{
						coinIsHeld = true;
						
						remove(coin);
						cursor.visible = false;
						cursor = handCoinSprite;
						cursor.visible = true;
						
						cameraPan01 = true;
						cameraPan01Timer.start(1.0);
					}
					if (FlxG.mouse.justPressed() && coinIsHeld && cursor.overlaps(coinFeed))
					{
						cursor.visible = false;
						cursor = handSprite;
						cursor.visible = true;
						gameMode = MODE_TURN;
						coinIsHeld = false;
						add(coin);
						coin.x = FlxG.width / 2 - 48 / 2 + dispenserOffsetX;
						coin.y = 140;
						coin.origin.y += 480 / 2 - 140;
					}
		}
		private function updateModeTurn():void
		{
			
		}
		private function updateModeRecieve():void
		{
			if (cameraPan02Primed && handleIsHeld == false)
			{
				cameraPan02Timer.start(1.0);
				cameraPan02 = true;
			}
			if (!handleIsHeld)
			{
				if (openHandCollider.overlaps(flapSprite))
				{
					if (cursor != handRecievingSprite)
					{
					cursor.visible = false;
					cursor = handRecievingSprite;
					cursor.visible = true;
					}
				}
				else
				{
					if (cursor != handSprite)
					{
						cursor.visible = false;
						cursor = handSprite;
						cursor.visible = true;
					}
				}
			}
		}
		
		private function updateDispenserTurn():void
		{
			
			if (FlxG.mouse.justPressed() && dispenserCollider.overlapsPoint(FlxG.mouse.getWorldPosition()))
					{
						handleIsHeld = true;
						cursor.visible = false;
						cursor = cursorDotSprite;
						cursor.visible = true;
						handTurnSprite.visible = true;
						armSprite.visible = true;
					}
					if (!FlxG.mouse.pressed() || ! dispenserCollider.overlapsPoint(FlxG.mouse.getWorldPosition()))
					{
						if (handleIsHeld)
						{
							cursor.visible = false;
							if (coinIsHeld)
								cursor = handCoinSprite;
							else
								cursor = handSprite;
							cursor.visible = true;
							handTurnSprite.visible = false;
							armSprite.visible = false;
						}
						handleIsHeld = false;
					}
					if (handleIsHeld)
					{
						var mouseDelta:FlxPoint = new FlxPoint(FlxG.mouse.x - lastMouseXY.x, FlxG.mouse.y - lastMouseXY.y);
						var handleCenter:FlxPoint = new FlxPoint(dispenserHandle.x + dispenserHandle.width / 2.0, dispenserHandle.y + dispenserHandle.health / 2.0);
						var lastMouseTranslated:FlxPoint = new FlxPoint(lastMouseXY.x - handleCenter.x, lastMouseXY.y - handleCenter.y);
						var mouseTranslated:FlxPoint = new FlxPoint(FlxG.mouse.x - handleCenter.x, FlxG.mouse.y - handleCenter.y);
						var thetaInitial:Number = Math.atan2(lastMouseTranslated.y, lastMouseTranslated.x);
						var thetaFinal:Number = Math.atan2(mouseTranslated.y, mouseTranslated.x);
						var deltaTheta:Number = thetaFinal - thetaInitial;
						while (deltaTheta > Math.PI)
						{
							deltaTheta -= Math.PI * 2;
						}
						while (deltaTheta < -Math.PI)
						{
							deltaTheta += Math.PI * 2;
						}
						
						deltaTheta = deltaTheta * 180.0 / Math.PI;
						
						var newTheta:Number = totalTheta + deltaTheta;
						if (gameMode == MODE_TURN && int(newTheta / snapAmount) < currentSnap)
						{
							deltaTheta = 0;
							totalTheta = currentSnap * snapAmount;
						}
						if (gameMode == MODE_TURN && int(totalTheta / snapAmount) < int(newTheta * snapAmount))
						{
							currentSnap = int(newTheta / snapAmount);
							
							//trace("CLICK!", currentSnap);
						}
						totalTheta += deltaTheta;
						if (totalTheta < 0)
							totalTheta = 0;
						
						if (gameMode == MODE_TURN && totalTheta >= goalTheta)
						{
							gameMode = MODE_RECIEVE;
							totalTheta = 0;
							cameraPan02Primed = true;
						}
						if ((gameMode == MODE_COIN || gameMode == MODE_RECIEVE) && totalTheta > snapbackThetaMax)
						{
							totalTheta = snapbackThetaMax;
						}
						
						//cursor.x = dispenserHandle.x + dispenserHandle.width / 2;
						//cursor.y = dispenserHandle.y + dispenserHandle.height / 2;
						//cursor.angle = dispenserHandle.angle;
						handTurnSprite.angle = dispenserHandle.angle;
						
						//armSprite.x = dispenserHandle.x + (dispenserHandle.width / 2 - 30) * Math.cos(totalTheta / 180 * Math.PI);
						//armSprite.y = dispenserHandle.y + 20  + (dispenserHandle.width / 2) * Math.sin((totalTheta + 25) / 180 * Math.PI);
						var angleOffsetX:Number =  Math.atan(24 / 56);
						var angleOffsetY:Number = Math.atan(56 / 24);
						armSprite.x = 70 * Math.cos(totalTheta / 180 * Math.PI + angleOffsetX ) + handleCenter.x - 100;
						armSprite.y = 80 * Math.sin(totalTheta / 180 * Math.PI + angleOffsetX ) + handleCenter.y + 20;
						//145x120
						//56x24
						//r = 61
						//43 x 43
					}
					else if((gameMode == MODE_COIN || gameMode == MODE_RECIEVE) && totalTheta > 0)
					{
						totalTheta -= 10;
						if (totalTheta < 0)
							totalTheta = 0;
					}
					dispenserHandle.angle = totalTheta;
					if (gameMode == MODE_TURN)
					{
						coin.angle = totalTheta;
						if (coin.angle > 20)
							remove(coin);
					}
		}
		/*
		private function pointCollidesWithHandle(point:FlxPoint):Boolean
		{
			if (dispenserCollider.overlapsPoint(point))
			{
				//check rotated rect
				var angleRad = dispenserHandle.angle * Math.PI / 180.0;
				var x1 = dispenserHandle.x;
				var y1 = dispenserHandle.y;
				var w1 = dispenserHandle.width;
				var h1 = dispenserHandle.height;
				var centerX = x1 + w1 / 2.0;
				var centerY = y1 + h1 / 2.0;
				//corners
				//origin = centerX, centerY
				var bl:FlxPoint = calcRotatedPoint(x1, y1 + h1, centerX, centerY, angleRad);
				var br:FlxPoint = calcRotatedPoint(x1 + w1, y1 + h1, centerX, centerY, angleRad);
				var tl:FlxPoint = calcRotatedPoint(x1, y1, centerX, centerY, angleRad);
				var tr:FlxPoint = calcRotatedPoint(x1 + w1, y1, centerX, centerY, angleRad);
				
				while(bl.x > br.x)
				{
					var tempPoint:FlxPoint = new FlxPoint(bl.x, bl.y);
					bl = br;
					br = tr;
					tr = tl;
					tl = tempPoint;
				}
				
				
				var mTop:Number = (tr.y - tl.y) / (tr.x - tl.x);
				var mLeft:Number = (bl.x - tl.x) / (bl.y - tl.y);
				var mBottom:Number = (br.y - bl.y) / (br.x - bl.x);
				var mRight:Number = (br.x - tr.x) / (br.y - tr.y);
				
				if (point.y < mBottom * (point.x - bl.x) + bl.y && point.y > mTop * (point.x - tl.x) + tl.y && 
					point.x > mLeft * (point.y - bl.y) + bl.x && point.x < mRight * (point.y - br.y) + br.x)
					return true;
				
			}
			return false;
		}
		*/
		private function swapPoints(p1:FlxPoint, p2:FlxPoint):void
		{
			var temp:FlxPoint = new FlxPoint(p1.x, p1.y);
			p1 = p2;
			p2 = temp;
		}
		
		private function swapNumbers(n1:Number, n2:Number):void
		{
			var temp:Number = n1;
			n1 = n2;
			n2 = temp;
		}
		
		//theta = radians
		private function calcRotatedPoint(x1:Number, y1:Number, centerX:Number, centerY:Number, theta:Number):FlxPoint
		{
			return calcRotatedPoint2(new FlxPoint(x1, y1), new FlxPoint(centerX, centerY), theta);
		}
		
		private function calcRotatedPoint2(point:FlxPoint, center:FlxPoint, theta:Number):FlxPoint
		{
			var x1:Number = point.x - center.x;
			var y1:Number = point.y - center.y;
			
			var x2:Number = x1 * Math.cos(theta) - y1 * Math.sin(theta);
			var y2:Number = x1 * Math.sin(theta) + y1 * Math.cos(theta);
			
			return new FlxPoint(x2 + center.x, y2 + center.y);
		}
	}

}